package com.diagbot.entity.node;

import com.diagbot.entity.node.base.BaseNode;
import lombok.Getter;
import lombok.Setter;
import org.neo4j.ogm.annotation.NodeEntity;
import org.neo4j.ogm.annotation.Property;
import org.neo4j.ogm.annotation.Relationship;

import java.util.Set;
import java.util.HashSet;

@Setter
@Getter
@NodeEntity(label = "实验室检查名称")
public class LisName extends BaseNode  {

	@Property(name = "单位")
	private String unit;

	@Property(name = "最小值")
	private Double minval;

	@Property(name = "最大值")
	private Double maxval;

	@Property(name = "范围")
	private Integer range;

	@Property(name = "静态知识")
	private String knowledge;

	@Relationship(type = "实验室检查名称相关实验室检查代码", direction = Relationship.OUTGOING)
	private Set<LisCode> liscodes = new HashSet<>();

	@Relationship(type = "实验室检查名称相关实验室检查别名", direction = Relationship.OUTGOING)
	private Set<LisAlias> lisaliass = new HashSet<>();

	@Relationship(type = "实验室检查名称相关实验室检查一级分类", direction = Relationship.OUTGOING)
	private Set<LisFirstClass> lisfirstclasss = new HashSet<>();

	@Relationship(type = "实验室检查名称相关实验室检查二级分类", direction = Relationship.OUTGOING)
	private Set<LisSecondClass> lissecondclasss = new HashSet<>();

	@Relationship(type = "实验室检查名称相关实验室检查套餐名", direction = Relationship.OUTGOING)
	private Set<LisSet> lissets = new HashSet<>();

	@Relationship(type = "实验室检查名称禁忌禁忌人群", direction = Relationship.OUTGOING)
	private Set<Group> groups = new HashSet<>();

	@Relationship(type = "实验室检查名称禁忌性别", direction = Relationship.OUTGOING)
	private Gender gender;

	@Relationship(type="实验室检查名称相关实验室检查危急值", direction = Relationship.OUTGOING)
	private Set<LISCritical> liscritials = new HashSet<>();

	@Relationship(type = "实验室检查名称相关医保疾病名称", direction = Relationship.OUTGOING)
	private Set<YiBaoDiseaseName> disease = new HashSet<>();

}