package com.diagbot.entity.node;

import com.diagbot.entity.node.base.BaseNode;
import lombok.Getter;
import lombok.Setter;
import org.neo4j.ogm.annotation.NodeEntity;
import org.neo4j.ogm.annotation.Property;
import org.neo4j.ogm.annotation.Relationship;

import java.util.Set;
import java.util.HashSet;

@Setter
@Getter
@NodeEntity(label = "医保疾病名称")
public class YiBaoDiseaseName extends BaseNode  {

	@Property(name = "性别")
	private String gender;

	@Relationship(type = "医保疾病名称相关医保ICD-10代码", direction = Relationship.OUTGOING)
	private Set<YiBaoICD_10Code> yibaoicd_10codes = new HashSet<>();

	@Relationship(type = "医保疾病名称相关国临疾病名称", direction = Relationship.OUTGOING)
	private Set<GuoLinDiseaseName> guolindiseasenames = new HashSet<>();

	@Relationship(type = "医保疾病名称相关国临ICD-10代码", direction = Relationship.OUTGOING)
	private Set<GuoLinICD_10Code> guolinicd_10codes = new HashSet<>();

	@Relationship(type = "医保疾病名称相关临床路径名称", direction = Relationship.OUTGOING)
	private Set<PathwayName> pathwaynames = new HashSet<>();

	@Relationship(type = "症状相关医保疾病名称", direction = Relationship.OUTGOING)
	private Set<Symptom> symptoms = new HashSet<>();

	@Relationship(type = "体征相关医保疾病名称", direction = Relationship.INCOMING)
	private Set<Vital> vitals = new HashSet<>();

	@Relationship(type = "实验室检查相关医保疾病名称", direction = Relationship.INCOMING)
	private Set<LisName> lisnames = new HashSet<>();

	@Relationship(type = "辅助检查名称相关医保疾病名称", direction = Relationship.INCOMING)
	private Set<PacsName> pacsnames = new HashSet<>();

	@Relationship(type = "实验室检查结果相关医保疾病名称", direction = Relationship.INCOMING)
	private Set<LisResult> lisresults = new HashSet<>();

}