package com.diagbot.repository;

import com.diagbot.dto.BillNeoDTO;
import com.diagbot.dto.LisBillNeoDTO;
import com.diagbot.dto.NeoEntityDTO;
import com.diagbot.dto.NodeNeoDTO;
import com.diagbot.entity.node.*;
import com.diagbot.util.NeoUtil;

import java.math.BigDecimal;
import java.util.*;

public class LisSetNode {

	public LisBillNeoDTO LisPacktoLISDTO(LisSet lisset) {

		LisBillNeoDTO lisBillNeoDTO = new LisBillNeoDTO();
		NodeInfo nodeInfo;

		Gender gender = lisset.getGender();
		if (null!=gender) {
			nodeInfo = new NodeInfo();
			nodeInfo.setName(gender.getName());
			nodeInfo.setTypeval(Constants.gender);
			lisBillNeoDTO.setGender(NeoUtil.updateNodeInfo(nodeInfo));
		}

/*
		Age age = lispack.getAge();
		if (null!=age) {
			NodeNeoDTO ageNeoDTO = new NodeNeoDTO();
			ageNeoDTO.setMin(BigDecimal.valueOf(age.getMinval()));
			ageNeoDTO.setMax(BigDecimal.valueOf(age.getMaxval()));
			ageNeoDTO.setName("年龄");
			lisBillNeoDTO.setAgeNeoDTO(ageNeoDTO);
		}

		Set<ClinicalFinding> clinicalfindings = lispack.getClinicalfindings();
		for (ClinicalFinding clinicalfinding : clinicalfindings) {
			nodeInfo = new NodeInfo();
			nodeInfo.setName(clinicalfinding.getName());
			nodeInfo.setMinval(NeoUtil.DoubletoBigDecimal(clinicalfinding.getMinval()));
			nodeInfo.setMaxval(NeoUtil.DoubletoBigDecimal(clinicalfinding.getMaxval()));
			nodeInfo.setUnit(clinicalfinding.getUnit());
			nodeInfo.setRange(clinicalfinding.getRange());
			lisBillNeoDTO.getClinicfindings().add(NeoUtil.updateNodeInfo(nodeInfo));
		}

		Set<Medicine> conflict_medicines = lispack.getConflict_medicines();
		for (Medicine conflict_medicine : conflict_medicines) {
			nodeInfo = new NodeInfo();
			nodeInfo.setName(conflict_medicine.getName());
			lisBillNeoDTO.getOralmeds().add(NeoUtil.updateNodeInfo(nodeInfo));
		}

		Set<AllergicMed> allergicmeds = lispack.getAllergicmeds();
		for (AllergicMed allergicmed : allergicmeds) {
			nodeInfo = new NodeInfo();
			nodeInfo.setName(allergicmed.getName());

			lisBillNeoDTO.getAllergicmeds().add(NeoUtil.updateNodeInfo(nodeInfo));
		}

		Set<Operation> operations = lispack.getOperations();
		for (Operation operation : operations) {
			nodeInfo = new NodeInfo();
			nodeInfo.setName(operation.getName());

			lisBillNeoDTO.getOperations().add(NeoUtil.updateNodeInfo(nodeInfo));
		}

		Set<Procedure> procedures = lispack.getProcedures();
		for (Procedure procedure : procedures) {
			nodeInfo = new NodeInfo();
			nodeInfo.setName(procedure.getName());
			lisBillNeoDTO.getProcedures().add(NeoUtil.updateNodeInfo(nodeInfo));
		}

		Set<PACS> pacss = lispack.getPacs();
		for (PACS pacs : pacss) {
			nodeInfo = new NodeInfo();
			nodeInfo.setName(pacs.getName());
			lisBillNeoDTO.getPacs().add(NeoUtil.updateNodeInfo(nodeInfo));
		}

		Set<Disease> diseases = lispack.getDiseases();
		for (Disease disease : diseases) {
			nodeInfo = new NodeInfo();
			nodeInfo.setName(disease.getName());
			lisBillNeoDTO.getDisease().add(NeoUtil.updateNodeInfo(nodeInfo));
		}

		Set<Group> groups = lispack.getGroups();
		for (Group group : groups) {
			nodeInfo = new NodeInfo();
			nodeInfo.setName(group.getName());
			lisBillNeoDTO.getGroup().add(NeoUtil.updateNodeInfo(nodeInfo));
		}
*/

		return lisBillNeoDTO;
	}


	/**
	 * 处理化验套餐开单合理性
	 */
	public List<BillNeoDTO> getLisBill(Map<String, String> lispackterm, LisSetRepository lisSetRepository) {
		List<BillNeoDTO> billNeoDTOs = new ArrayList<>();
		BillNeoDTO billNeoDTO;

		LisBillNeoDTO lisBillNeoDTO;

		List<LisSet> lisSetlist;
		String lissetname;

		for (String term : lispackterm.keySet()) {
			billNeoDTO = new BillNeoDTO();
			lissetname = lispackterm.get(term);
			billNeoDTO.setName(term);
			billNeoDTO.setStandname(lissetname);

			lisBillNeoDTO = new LisBillNeoDTO();

			lisSetlist = lisSetRepository.findByNameIs(lissetname);

			if (lisSetlist != null && lisSetlist.size()>0) {
				lisBillNeoDTO = LisPacktoLISDTO(lisSetlist.get(0));
			}

			billNeoDTO.setLisBillNeoDTO(lisBillNeoDTO);

			billNeoDTOs.add(billNeoDTO);
		}

		return billNeoDTOs;
	}



	/**
	 * 获取化验套餐名称列表
	 */
	public List<String> getLISPackNameList(String name, LisSetRepository lisPackRepository) {
		String nodename;

		List<String> lispacklist = new ArrayList<>();

		List<LisSet> lisSetlist = lisPackRepository.findByNameContaining(name);

		for (LisSet lisSet : lisSetlist) {
			nodename = lisSet.getName();
			if (!lispacklist.contains(nodename)) {
				lispacklist.add(nodename);
			}
		}


		return lispacklist;
	}



	/**
	 * 更新实体属性信息
	 */
	public NeoEntityDTO updateEntity(String name, Map<String, String> props, List<String> keys, LisSetRepository lisPackRepository) {
		NeoEntityDTO neoEntityDTO = new NeoEntityDTO();
		neoEntityDTO.setName(name);

		try {
			List<LisSet> lisSetres = lisPackRepository.findByNameIs(name);

			if (lisSetres!= null && lisSetres.size()>0) {
				LisSet lisSet = lisSetres.get(0);

				for (String key : props.keySet()) {
					switch (key) {
						case "最大值":
							lisSet.setMaxval(Double.parseDouble(props.get(key)));
							break;
						case "最小值":
							lisSet.setMinval(Double.parseDouble(props.get(key)));
							break;
						case "单位":
							lisSet.setUnit(props.get(key));
							break;
					}
				}

				lisSet = lisPackRepository.save(lisSet);

				neoEntityDTO = fillNeoDTO(lisSet, keys);
			}
		}
		catch (Exception ex) {
			ex.printStackTrace();
		}

		return neoEntityDTO;
	}


	private NeoEntityDTO fillNeoDTO(LisSet lisSet, List<String> keys) {
		NeoEntityDTO neoEntityDTO = new NeoEntityDTO();
		Map<String, String> props = new HashMap<>();
		String val = "";

		neoEntityDTO.setName(lisSet.getName());
		for (String key:keys) {
			switch(key) {
				case "最大值":
					val = String.format("%.2f",lisSet.getMaxval());
					break;
				case "最小值":
					val = String.format("%.2f", lisSet.getMinval());
					break;
				case "单位":
					val = lisSet.getUnit();
					break;
			}
			props.put(key, val);
		}
		neoEntityDTO.setProperty(props);

		return neoEntityDTO;
	}

}

