package com.diagbot.repository;

import com.diagbot.dto.HighRiskNeoDTO;
import com.diagbot.entity.node.MedCodeName;
import com.diagbot.entity.node.MedRegName;
import com.diagbot.entity.node.Medicine;
import com.diagbot.vo.Drug;

import java.util.ArrayList;
import java.util.List;


public class MedRegNameNode {

    /**
     * 获取高危药品数据
     */
    public List<HighRiskNeoDTO> getHighRiskDrug(List<Drug> druglist, MedicineRepository medRepository,
                                                MedicineCodeRepository medCodeRepository) {
        List<HighRiskNeoDTO> highRiskNeoDTOS = new ArrayList<>();
        HighRiskNeoDTO highRiskNeoDTO;
        String drugname, drugform;
        List<Medicine> medicine;
        List<MedCodeName> medcdnames;
        MedRegName medreg;

        for (Drug drug : druglist) {
            highRiskNeoDTO = new HighRiskNeoDTO();

            drugname = drug.getUniqueName();
            highRiskNeoDTO.setName(drug.getName());
            highRiskNeoDTO.setStandname(drugname);
            drugform = drug.getForm();

            medicine = medRepository.findByNameIs(drugname);

            if (null != medicine) {
                for (Medicine med: medicine) {
                    for (MedCodeName medcdname : med.getMedcodenames()) {
                        if (medcdname.getReg_JiXin().equals(drugform)) {
                            medcdnames = medCodeRepository.findByNameIs(medcdname.getName());
                            for (MedCodeName medcdnm : medcdnames) {
                                List<MedRegName> medRegNames = new ArrayList<>(medcdnm.getMedregnames());
                                medreg = medRegNames.get(0);
                                if (null != medreg.getRisklevel() && medreg.getRisklevel().trim().length() > 0) {
                                    highRiskNeoDTO.setIsHighrisk(true);
                                    highRiskNeoDTO.setType(Constants.yaoping);
                                    highRiskNeoDTO.setForm(drugform);
                                    highRiskNeoDTOS.add(highRiskNeoDTO);
                                    break;
                                }
                            }

                            if (highRiskNeoDTO.getType()!=null) {
                                break;
                            }
                        }
                    }

                    if (highRiskNeoDTO.getType()!=null) {
                        break;
                    }

                }
            }
        }

        return highRiskNeoDTOS;
    }

}

