package com.diagbot.rule;

import com.diagbot.biz.push.entity.Item;
import com.diagbot.dto.BillMsg;
import com.diagbot.dto.BillNeoMaxDTO;
import com.diagbot.dto.NodeNeoDTO;
import com.diagbot.dto.WordCrfDTO;
import com.diagbot.util.CoreUtil;

import java.util.List;

/**
 * @description: 人群规则
 * @author: zhoutg
 * @time: 2020/8/3 14:47
 */
public class GroupRule {

    /**
     * 禁忌人群
     *
     * @param wordCrfDTO
     * @param billNeoMaxDTO
     * @return
     */
    public static void compareGroupWithBill(WordCrfDTO wordCrfDTO, BillNeoMaxDTO billNeoMaxDTO, List<BillMsg> billMsgList, String type) {
        List<NodeNeoDTO> group = billNeoMaxDTO.getGroup();
        for (NodeNeoDTO node : group) {
            // 妊娠目前从诊断里判断,包含“妊娠”
            if ("妊娠".equals(node.getName())) {
                List<Item> diag = wordCrfDTO.getDiag();
                for (Item item : diag) {
                    if (item.getUniqueName().contains("妊娠")) {
                        BillMsg commonBillMsg = CoreUtil.getCommonBillMsg(
                                billNeoMaxDTO.getOrderName(), billNeoMaxDTO.getOrderStandName(),
                                item.getUniqueName(), type);
                        billMsgList.add(commonBillMsg);
                    }
                }
            }
        }
    }
}
