package com.diagbot.util;

import com.diagbot.dto.NodeNeoDTO;
import com.diagbot.dto.PushBaseDTO;
import com.diagbot.repository.Constants;
import com.diagbot.repository.NodeInfo;
import com.diagbot.repository.datautil;

import java.math.BigDecimal;

public class NeoUtil {

    public static NodeNeoDTO updateNodeInfo(NodeInfo nodeInfo) {
        NodeNeoDTO nodeNeoDTO = new NodeNeoDTO();

        String name = nodeInfo.getName();
        name = (null==name)?"":name;
        name = datautil.removekey(name, Constants.conflict);
        nodeNeoDTO.setName(name);

        BigDecimal min = nodeInfo.getMinval();
        if (null!=min) {
            nodeNeoDTO.setMin(min);
        }

        BigDecimal max = nodeInfo.getMaxval();
        if (null!=max) {
            nodeNeoDTO.setMax(max);
        }

        String unit = nodeInfo.getUnit();
        unit = (null==unit)?"":unit;
        nodeNeoDTO.setUnit(unit);

        Integer range = nodeInfo.getRange();
        range = (null==range)?0:range;
        nodeNeoDTO.setValType(range);

        String type = nodeInfo.getTypeval();
        type = (null==type)?"":type;
        nodeNeoDTO.setTermtype(type);

        return nodeNeoDTO;
    }




    public static PushBaseDTO updatePushInfo(String name) {
        PushBaseDTO pushBaseDTO = new PushBaseDTO();

        name = (null==name)?"":name;
        pushBaseDTO.setName(name);

        return pushBaseDTO;
    }

    public static BigDecimal DoubletoBigDecimal(Double val) {
        BigDecimal bd = null;
        if (null!=val) {
            bd = new BigDecimal(val.toString());
        }

        return bd;
    }

    public static BigDecimal StringtoBigDecimal(String val) {
        BigDecimal bd = null;
        if (StringUtil.isNotBlank(val)) {
            bd = new BigDecimal(val);
        }

        return bd;
    }
}
