package com.diagbot.vo;

import lombok.Getter;
import lombok.Setter;

import javax.validation.constraints.NotBlank;
import java.util.ArrayList;
import java.util.List;

/**
 * @Description:病情提示入参
 * @Author:zhaops
 * @time: 2020/7/29 15:35
 */
@Getter
@Setter
public class IndicationPushVO extends SearchData {
    /**
     * 规则类型（1:危急值提醒，2:开单合理项，3:高危药品、手术，4:其他提醒）
     */
    @NotBlank(message = "ruleType不能为空")
    private String ruleType = "";

    List<String> ruleTypeList = new ArrayList<>();
    // 文件的行号，测试文件数据用
    private String idNum;
}
